pipeline {
    environment {
        IMAGE_NAME = "static-website"
        IMAGE_TAG = "latest"
        IP_ADDRESS = "3.235.28.200"
        IP_STAGING = "44.203.240.214"
        IP_PRODUCTION = "3.93.34.220"
        USER_SERVER = "ubuntu"
    }
    agent none
    stages {
        stage('Build image') {
            agent any
            steps {
                script {
                    sh 'docker build -t $IMAGE_NAME:$IMAGE_TAG .'  
                }
            }
        }
        stage('Run container based on builded image') {
            agent any
            steps {
                script {               
                        sh 'docker run --name ${IMAGE_NAME}-test -d -p 80:80 $IMAGE_NAME:$IMAGE_TAG'
                        sleep 10                    
                }
            }
        }
        stage('Test image') {
            agent any
            steps {
                script {
                    sh '''
                        IP_TEST=$(docker inspect -f '{{range .NetworkSettings.Networks}}{{.IPAddress}}{{end}}' "${IMAGE_NAME}-test")
                        curl "http://$IP_ADDRESS"
                        echo "$IP_TEST"
                    '''  
                }
            }
        }
        stage('Clean test') {
            agent any
            steps {
                script {
                    sh '''
                        docker stop ${IMAGE_NAME}-test 
                        docker rm ${IMAGE_NAME}-test
                    '''
                }
            }
        }
        stage('Release image') {
            environment {
                DOCKERHUB_USER = credentials('DHUB_USER')
                DOCKERHUB_TOKEN = credentials('DHUB_TOKEN')                
            }
            agent any
            steps {
                script {                    
                    sh 'docker tag $IMAGE_NAME:$IMAGE_TAG $DOCKERHUB_USER/$IMAGE_NAME:$IMAGE_TAG'
                    sh 'docker tag $IMAGE_NAME:$IMAGE_TAG $DOCKERHUB_USER/$IMAGE_NAME:$GIT_COMMIT'
                    sh 'echo $DOCKERHUB_TOKEN | docker login -u $DOCKERHUB_USER --password-stdin'
                    sh 'docker push $DOCKERHUB_USER/$IMAGE_NAME:$IMAGE_TAG'
                    sh 'docker push $DOCKERHUB_USER/$IMAGE_NAME:$GIT_COMMIT'  
                    sh 'echo "Pushing the image to DockerHub..." '
                }
            }
        }
        stage('Deploy review') {   
            environment {
                EC2_SSH_KEY = credentials('DEVOPS')
                DOCKERHUB_USER = credentials('DHUB_USER')
                DOCKERHUB_TOKEN = credentials('DHUB_TOKEN')
            }
            agent any
            steps {
                script { 
                    sh''' 
                        ssh -o StrictHostKeyChecking=no -i $EC2_SSH_KEY ${USER_SERVER}@${IP_STAGING} "
                        docker login -u \$DOCKERHUB_USER -p \$DOCKERHUB_TOKEN
                        docker pull \$DOCKERHUB_USER/\$IMAGE_NAME:\$IMAGE_TAG
                        docker stop \$IMAGE_NAME || true
                        docker rm \$IMAGE_NAME || true
                        docker run -d --name \$IMAGE_NAME -p 80:80 \$DOCKERHUB_USER/\$IMAGE_NAME:\$IMAGE_TAG
                        "
                    '''
                }
            }
        }
        stage('Test staging') {
            agent any
            steps {
                script {
                    sh '''                        
                        curl -I "http://$IP_STAGING"
                    '''  
                }
            }
        }
        stage('Deploy production') {
            when {
                branch 'main'
            }
            environment {
                EC2_SSH_KEY = credentials('DEVOPS')
                DOCKERHUB_USER = credentials('DHUB_USER')
                DOCKERHUB_TOKEN = credentials('DHUB_TOKEN')
            }
            agent any
            steps {
                script { 
                    sh''' 
                        ssh -o StrictHostKeyChecking=no -i $EC2_SSH_KEY ${USER_SERVER}@${IP_PRODUCTION} "
                        docker login -u \$DOCKERHUB_USER -p \$DOCKERHUB_TOKEN
                        docker pull \$DOCKERHUB_USER/\$IMAGE_NAME:\$IMAGE_TAG
                        docker stop \$IMAGE_NAME || true
                        docker rm \$IMAGE_NAME || true
                        docker run -d --name \$IMAGE_NAME -p 80:80 \$DOCKERHUB_USER/\$IMAGE_NAME:\$IMAGE_TAG
                        "
                    '''
                }
            }
        }
        stage('Test production') {
            agent any
            steps {
                script {
                    sh '''                        
                        curl -I "http://$IP_PRODUCTION"
                    '''  
                }
            }
        }
    }    
}